package pl.waw.ipipan.corpcor.server.model;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Version;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Past;

import pl.waw.ipipan.corpcor.shared.AnnotationValidation;

@Entity
public class Annotation implements Serializable, AnnotationValidation {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private Long id;
	
	private Long userId;
	private String userName;
	/*@NotNull*/ private Date added;
	@NotNull private String segmentId;
	@NotNull private String blockId;
	@NotNull private String textId;
	private String orth;
	private String base;
	private String msd;
	private String ctag;
	private String query;
	private String comment;
	private boolean deleted;
	private String lastOrth;
	private String lastBase;
	private String lastMsd;
	private String lastCtag;
	private boolean lastDeleted;
	
	@Version
	@Column(name = "version")
	private Integer version;

	public Long getId() {
		return id;
	}

	public Long getUserId() {
		return userId;
	}
	
	public void setUserId(Long userId) {
		this.userId = userId;
	}
	
	public String getUserName() {
		return userName;
	}

	public void setUserName(String userName) {
		this.userName = userName;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Date getAdded() {
		return added;
	}

	public void setAdded(Date added) {
		this.added = added;
	}

	public String getSegmentId() {
		return segmentId;
	}

	public void setSegmentId(String segmentId) {
		this.segmentId = segmentId;
	}

	public String getBlockId() {
		return blockId;
	}

	public void setBlockId(String blockId) {
		this.blockId = blockId;
	}

	public String getTextId() {
		return textId;
	}

	public void setTextId(String textId) {
		this.textId = textId;
	}

	public String getOrth() {
		return orth;
	}

	public void setOrth(String orth) {
		this.orth = orth;
	}

	public String getBase() {
		return base;
	}

	public void setBase(String base) {
		this.base = base;
	}

	public String getMsd() {
		return msd;
	}

	public void setMsd(String msd) {
		this.msd = msd;
	}

	public String getCtag() {
		return ctag;
	}

	public void setCtag(String ctag) {
		this.ctag = ctag;
	}

	public String getQuery() {
		return query;
	}

	public void setQuery(String query) {
		this.query = query;
	}

	public String getComment() {
		return comment;
	}

	public void setComment(String comment) {
		this.comment = comment;
	}

	public void setVersion(Integer version) {
		this.version = version;
	}

	public Integer getVersion() {
		return version;
	}

	public String getLastOrth() {
		return lastOrth;
	}

	public void setLastOrth(String lastOrth) {
		this.lastOrth = lastOrth;
	}

	public String getLastBase() {
		return lastBase;
	}

	public void setLastBase(String lastBase) {
		this.lastBase = lastBase;
	}

	public String getLastMsd() {
		return lastMsd;
	}

	public void setLastMsd(String lastMsd) {
		this.lastMsd = lastMsd;
	}

	public String getLastCtag() {
		return lastCtag;
	}

	public void setLastCtag(String lastCtag) {
		this.lastCtag = lastCtag;
	}

	public boolean isDeleted() {
		return deleted;
	}

	public void setDeleted(boolean deleted) {
		this.deleted = deleted;
	}

	public boolean isLastDeleted() {
		return lastDeleted;
	}

	public void setLastDeleted(boolean lastDeleted) {
		this.lastDeleted = lastDeleted;
	}
}
